| TagLib 1.13 |  |

Public Types | Public Member Functions | Static Public Member Functions | List of all members
TagLib::MP4::File Class Reference

`#include <mp4file.h>`

Inheritance diagram for TagLib::MP4::File:
[legend]
Collaboration diagram for TagLib::MP4::File:
[legend]

## Public Types
enum | TagTypes { NoTags = 0x0000 , MP4 = 0x0001 , AllTags = 0xffff }
Public Types inherited from TagLib::File
enum | Position { Beginning , Current , End }
enum | StripTags { StripNone , StripOthers }
enum | DuplicateTags { Duplicate , DoNotDuplicate }

## Public Member Functions
| File (FileName file, bool readProperties=true, Properties::ReadStyle audioPropertiesStyle=Properties::Average)
| File (IOStream *stream, bool readProperties=true, Properties::ReadStyle audioPropertiesStyle=Properties::Average)
virtual | ~File ()
Tag * | tag () const
PropertyMap | properties () const
void | removeUnsupportedProperties (const StringList &properties)
PropertyMap | setProperties (const PropertyMap &)
Properties * | audioProperties () const
bool | save ()
bool | strip (int tags=AllTags)
bool | hasMP4Tag () const
Public Member Functions inherited from TagLib::File
virtual | ~File ()
FileName | name () const
virtual Tag * | tag () const =0
PropertyMap | properties () const
void | removeUnsupportedProperties (const StringList &properties)
PropertyMap | setProperties (const PropertyMap &properties)
virtual AudioProperties * | audioProperties () const =0
virtual bool | save ()=0
ByteVector | readBlock (unsigned long length)
void | writeBlock (const ByteVector &data)
long | find (const ByteVector &pattern, long fromOffset=0, const ByteVector &before=ByteVector())
long | rfind (const ByteVector &pattern, long fromOffset=0, const ByteVector &before=ByteVector())
void | insert (const ByteVector &data, unsigned long start=0, unsigned long replace=0)
void | removeBlock (unsigned long start=0, unsigned long length=0)
bool | readOnly () const
bool | isOpen () const
bool | isValid () const
void | seek (long offset, Position p=Beginning)
void | clear ()
long | tell () const
long | length ()

## Static Public Member Functions
static bool | isSupported (IOStream *stream)
Static Public Member Functions inherited from TagLib::File
static TAGLIB_DEPRECATED bool | isReadable (const char *file)
static TAGLIB_DEPRECATED bool | isWritable (const char *name)

## Additional Inherited Members
Protected Member Functions inherited from TagLib::File
| File (FileName file)
| File (IOStream *stream)
void | setValid (bool valid)
void | truncate (long length)
Static Protected Member Functions inherited from TagLib::File
static unsigned int | bufferSize ()

## Detailed Description

This implements and provides an interface for MP4 files to the TagLib::Tag and TagLib::AudioProperties interfaces by way of implementing the abstract TagLib::File API as well as providing some additional information specific to MP4 files.

## Member Enumeration Documentation

## ◆ TagTypes

enum TagLib::MP4::File::TagTypes

This set of flags is used for strip() and is suitable for being OR-ed together.

Enumerator
NoTags | Empty set. Matches no tag types.
MP4 | Matches MP4 tags.
AllTags | Matches all tag types.

## Constructor & Destructor Documentation

## ◆ File() [1/2]

TagLib::MP4::File::File | ( | FileName | file,
|  | bool | readProperties = `true`,
|  | Properties::ReadStyle | audioPropertiesStyle = `Properties::Average`
| ) |  |

Constructs an MP4 file from file. If readProperties is true the file's audio properties will also be read.

Note
  In the current implementation, propertiesStyle is ignored.

## ◆ File() [2/2]

TagLib::MP4::File::File | ( | IOStream * | stream,
|  | bool | readProperties = `true`,
|  | Properties::ReadStyle | audioPropertiesStyle = `Properties::Average`
| ) |  |

Constructs an MP4 file from stream. If readProperties is true the file's audio properties will also be read.

Note
  TagLib will not take ownership of the stream, the caller is responsible for deleting it after the File object.
  In the current implementation, propertiesStyle is ignored.

## ◆ ~File()

virtual TagLib::MP4::File::~File | ( |  | ) |
| virtual

Destroys this instance of the File.

Reimplemented from TagLib::File.

## Member Function Documentation

## ◆ audioProperties()

Properties * TagLib::MP4::File::audioProperties | ( |  | ) | const
| virtual

Returns the MP4 audio properties for this file.

Implements TagLib::File.

## ◆ hasMP4Tag()

bool TagLib::MP4::File::hasMP4Tag | ( |  | ) | const

Returns whether or not the file on disk actually has an MP4 tag, or the file has a Metadata Item List (ilst) atom.

## ◆ isSupported()

static bool TagLib::MP4::File::isSupported | ( | IOStream * | stream | ) |
| static

Returns whether or not the given stream can be opened as an ASF file.

Note
  This method is designed to do a quick check. The result may not necessarily be correct.

## ◆ properties()

PropertyMap TagLib::MP4::File::properties | ( |  | ) | const

Implements the unified property interface – export function.

## ◆ removeUnsupportedProperties()

void TagLib::MP4::File::removeUnsupportedProperties | ( | const StringList & | properties | ) |

Removes unsupported properties. Forwards to the actual Tag's removeUnsupportedProperties() function.

## ◆ save()

bool TagLib::MP4::File::save | ( |  | ) |
| virtual

Save the file.

This returns true if the save was successful.

Implements TagLib::File.

## ◆ setProperties()

PropertyMap TagLib::MP4::File::setProperties | ( | const PropertyMap & |  | ) |

Implements the unified property interface – import function.

## ◆ strip()

bool TagLib::MP4::File::strip | ( | int | tags = `AllTags` | ) |

This will strip the tags that match the OR-ed together TagTypes from the file. By default it strips all tags. It returns true if the tags are successfully stripped.

Note
  This will update the file immediately.

## ◆ tag()

Tag * TagLib::MP4::File::tag | ( |  | ) | const
| virtual

Returns a pointer to the MP4 tag of the file.

MP4::Tag implements the tag interface, so this serves as the reimplementation of TagLib::File::tag().

Note
  The Tag is still owned by the MP4::File and should not be deleted by the user. It will be deleted when the file (object) is destroyed.

Implements TagLib::File.

The documentation for this class was generated from the following file:

- mp4file.h